#include "Form1.frm"

*
**
***
METHOD Form2OnShow( oSender ) CLASS TForm1

   If ::BarCod1:Control == NIL
      MessageDlg( "No se encontr el control ActiveX 'BarCod32.ocx'.", mtError, mbOk, poActiveCenter )
      ::Visible := .F.
      Application:Terminate()
      return
   endif

   ::BarCod1:Visible := .F.
   ::BarCod1:Control:Style := 19    //EAN 128
   ::BarCod1:Control:BarWidth := 1  //Amplada de les barras, en pixels
   ::Barcod1:Control:PrinterScaleMode := 3 //Pixels

return

*
**
***
METHOD Edit3OnChange( oSender ) CLASS TForm1

   ::Label4:Caption := If( ::Edit3:Caption = 1, "Etiqueta", "Etiquetes" )

return

*
**
***
METHOD ButtonImprimirOnClick( oSender ) CLASS TForm1
   local aRect, nLeft, nTop, nLin, nCol, nEtiquetes
   local nAlt := 36
   local nAmple := 210 /3

*/*
//Creo una finestra de  Preview
local oForm, oOwner, FPreview
oForm := TForm():Create( oOwner )
oForm:SetSize( 800, 600 )
oForm:Position := poScreenCenter
FPreview := TPreview():Create( oForm )
*/

   //Inicialitzo el document
   Printer:BeginDoc()
   Printer:Title := "Impressi CodiBarres "

   nLin := 8
   nCol := 0
   nEtiquetes := ::Edit3:Caption
   While nEtiquetes > 0
      If nLin > 7
         Printer:NewPage()
         nLin := 0
      EndIf

      If ::Edit4:Caption < 25 .and. nEtiquetes == ::Edit3:Caption
         nLin := Str( ::Edit4:Caption / 3, 5, 2 )
         If Right(nLin,2) ="00"
            nLin := Val( Left( nLin, 2 ) ) -1
         Else
            nLin := Int( Val( nLin ) )
         EndIf
         nCol := ::Edit4:Caption - ( 3 * nLin ) -1
      EndIf

      nLeft := 0 +(nCol*nAmple)
      nTop := 4 +(nLin*nAlt)
      nTop += If( nLin>3, nLin-3, 0 )
      PrinterDrawBox( { nLeft, nTop, nLeft +nAmple, nTop +nAlt } )

      ::BarCod1:Control:Caption := ::Edit1:Caption
      nLeft += 15
      PrinterDrawText( ::label1:Caption + "  " + ::Edit1:Caption, { nLeft, nTop +5, nLeft+65, nTop+8}, TA_LEFT )
      aRect := Printer:Millimeter2Printer( { nLeft, nTop +9, 25, 8 } )
      ::Barcod1:Control:PrinterLeft   := aRect[1]
      ::Barcod1:Control:PrinterTop    := aRect[2]
      ::Barcod1:Control:PrinterWidth  := aRect[3]
      ::Barcod1:Control:PrinterHeight := aRect[4]
      ::BarCod1:Control:BarWidth := 5
      ::Barcod1:Control:PrinterHDC := Printer:Handle

      ::BarCod1:Control:Caption := ::Edit2:Caption
      nTop += 15
      PrinterDrawText( ::label2:Caption + "  " + ::Edit2:Caption, { nLeft, nTop +5, nLeft +60, nTop +8}, TA_LEFT )
      aRect := Printer:Millimeter2Printer( { nLeft, nTop +9, 35, 10 } )
      ::Barcod1:Control:PrinterLeft   := aRect[1]
      ::Barcod1:Control:PrinterTop    := aRect[2]
      ::Barcod1:Control:PrinterWidth  := aRect[3]
      ::Barcod1:Control:PrinterHeight := aRect[4]
      ::BarCod1:Control:BarWidth := 7
      ::Barcod1:Control:PrinterHDC := Printer:Handle

      nEtiquetes --
      nCol := If( nCol = 2, 0, nCol +1 )
      If nCol = 0
         nLin++
      EndIf
   EndDo

   Printer:EndDoc()
*/*
//Visualitzo el Preview
Printer:Preview()
FPreview:SetBounds( 0, 0, oForm:ClientWidth -9, oForm:ClientHeight -35 )
FPreview:ViewZoom() //FullSize()
oForm:ShowModal()
oForm:Destroy()
*/
   Printer:Print()

return

//--------------------------------------------------------------------------//
//--------------------------------------------------------------------------//
/*
 * Dibuja un texto.
*/
Procedure PrinterDrawText( cText, aRect, nAlign )

   aRect := Printer:Millimeter2Printer( aRect )

   If nAlign == TA_LEFT
      SetTextAlign( Printer:Handle, TA_LEFT )
      ExtTextOut( Printer:Handle, aRect[ 1 ], aRect[ 2 ], ETO_CLIPPED, aRect, cText, Len( cText ), 0 )
   ElseIf nAlign == TA_RIGHT
      SetTextAlign( Printer:Handle, TA_RIGHT )
      ExtTextOut( Printer:Handle, aRect[ 3 ], aRect[ 2 ], ETO_CLIPPED, aRect, cText, Len( cText ), 0 )
   Else
      SetTextAlign( Printer:Handle, TA_CENTER )
      ExtTextOut( Printer:Handle, aRect[ 1 ] + ( aRect[ 3 ] - aRect[ 1 ] ) / 2, aRect[ 2 ], ETO_CLIPPED, aRect, cText, Len( cText ), 0 )
   EndIf

Return

/*
 * Genera un recuadro.
 */
Static Procedure PrinterDrawBox( aPoints )

   aPoints := Printer:Millimeter2Printer( aPoints )
   Rectangle( Printer:Handle, aPoints[ 1 ], aPoints[ 2 ], aPoints[ 3 ], aPoints[ 4 ] )

Return
